require 'sketchup.rb'

def gl_distort

model = Sketchup.active_model
entities = model.entities
selection = model.selection

prompts = ['Random Distortion Distance']
defaults = [0.to_l]
results = UI.inputbox prompts, defaults, 'Distance for random distortion:'
distance = results [0]

model.start_operation "Distort"

selection.each do |e|
   if (e.is_a? Sketchup::Face)   
         for v in e.vertices
                 xrand=(-distance/2)+distance*rand
                 yrand=(-distance/2)+distance*rand
                 zrand=(-distance/2)+distance*rand
                 # puts(xrand, yrand, zrand)         
                 vector = Geom::Vector3d.new xrand,yrand,zrand
                 tr = Geom::Transformation.translation vector
                 Sketchup.active_model.entities.transform_entities(tr, v)
           end #for
   end #if
end #do

model.commit_operation

end #main



### Menu ###

if not file_loaded?(__FILE__)

  UI.menu("Plugins").add_item("~~~Distort~~~"){gl_distort}

end #if


file_loaded(__FILE__)